## freespace2 24.2.0+repack

=== CMakeLists.txt ===

CMAKE_MINIMUM_REQUIRED(VERSION 3.4)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

# Make sure the source and binary directory are not the sample
if ("${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
	message(FATAL_ERROR "Binary and source directory can not be the same! Choose another build directory.")
endif()

include(cmake/util.cmake)
include(cmake/embed_file.cmake)

# Set a few policies
set_policy(CMP0051 NEW)
set_policy(CMP0053 NEW)
set_policy(CMP0054 NEW)

SET(FSO_PROJECT_DESCRIPTION "Open source project based on the original FreeSpace 2 source code.")

SET(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin CACHE PATH "Executable output path")
SET(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin CACHE PATH "Library output path")

# CMAKE_INSTALL_PREFIX is defined but also overwritten by the PROJECT command so we need to set it later
IF(NOT DEFINED CMAKE_INSTALL_PREFIX)
	SET(RESET_INSTALL_PREFIX TRUE)
ENDIF(NOT DEFINED CMAKE_INSTALL_PREFIX)

# Reset this variable
SET(TARGET_COPY_FILES "" CACHE INTERNAL "" FORCE)
SET(TARGET_COPY_DIRS "" CACHE INTERNAL "" FORCE)

### Define options and editable variables in the section below:
# This is only needed for single configuration generators so don't annoy others
if(NOT CMAKE_BUILD_TYPE AND NOT DEFINED CMAKE_CONFIGURATION_TYPES)
	set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Default build configuration used." FORCE)
	message(WARNING "CMAKE_BUILD_TYPE was not specified, defaulting to Release configuration.")
endif(NOT CMAKE_BUILD_TYPE AND NOT DEFINED CMAKE_CONFIGURATION_TYPES)

# Override standard CMake configurations
set(CMAKE_CONFIGURATION_TYPES Debug Release FastDebug CACHE STRING "Available configurations" FORCE)

set(FSO_LANGUAGES C CXX)

if(APPLE)
	set(FSO_LANGUAGES ${FSO_LANGUAGES} OBJC OBJCXX)
endif()

PROJECT(FS2_Open LANGUAGES ${FSO_LANGUAGES})

IF(CMAKE_CROSSCOMPILING)
	SET(IMPORT_EXE_DIR "IMPORT_EXE_DIR-NOTFOUND" CACHE FILEPATH "Required for a cross compiling build, point to binary directory of a cmake build for the real OS")
	INCLUDE(${IMPORT_EXE_DIR}/ImportExecutables.cmake)
ENDIF(CMAKE_CROSSCOMPILING)

# Check if the external modules exists
IF(NOT IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/cmake/external/rpavlik-cmake-modules/launcher-templates")
	message(FATAL_ERROR "External submodules could not be found. Please make sure you have updated your submodules.")
endif()

LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/finder")
LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/external/rpavlik-cmake-modules")
LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/external/cotire")

IF(RESET_INSTALL_PREFIX)
	IF(NOT $ENV{FS2PATH} STREQUAL "")
		IF(NOT IS_DIRECTORY $ENV{FS2PATH})
			MESSAGE(WARNING "The path '$ENV{FS2PATH}' of the environment variable FS2PATH does not point to a directory! Install prefix wasn't set.")
		ELSE(NOT IS_DIRECTORY $ENV{FS2PATH})
			SET(CMAKE_INSTALL_PREFIX "$ENV{FS2PATH}" CACHE FILEPATH "Install path" FORCE)
			FILE(TO_CMAKE_PATH ${CMAKE_INSTALL_PREFIX} CMAKE_INSTALL_PREFIX)
		ENDIF(NOT IS_DIRECTORY $ENV{FS2PATH})
	ELSE(NOT $ENV{FS2PATH} STREQUAL "")
		MESSAGE(STATUS "NO FS2PATH environment variable found, you can define this to point to your freespace install but it is not required.")
	ENDIF(NOT $ENV{FS2PATH} STREQUAL "")
ENDIF(RESET_INSTALL_PREFIX)

IF(WIN32 OR APPLE)
	OPTION(FSO_USE_SPEECH "Use text-to-speach libraries" ON)
ENDIF(WIN32 OR APPLE)

IF (WIN32)
	OPTION(FSO_USE_VOICEREC "Enable voice recognition support" ON)

	OPTION(FSO_BUILD_FRED2 "Build FRED2 binary" ON)
elseif(UNIX)
	option(FSO_BUILD_APPIMAGE "Build an AppImage package" OFF)
ENDIF(WIN32)

OPTION(FSO_BUILD_TOOLS "Build tools related to FSO" OFF)

OPTION(FSO_BUILD_TESTS "Build unit tests" OFF)

OPTION(FSO_DEVELOPMENT_MODE "Generate binaries in development mode, only use if you know what you're doing!" OFF)

OPTION(FSO_BUILD_QTFRED "Build qtFRED2 binary" OFF)

IF(WIN32 OR APPLE)
	# On windows and mac the default should be to always build the included libraries
	SET(FSO_BUILD_INCLUDED_LIBS_DEFAULT ON)
ELSE()
	SET(FSO_BUILD_INCLUDED_LIBS_DEFAULT OFF)
ENDIF()

OPTION(FSO_BUILD_INCLUDED_LIBS "Build and use the included libraries istead of using the system headers and libraries" ${FSO_BUILD_INCLUDED_LIBS_DEFAULT})

OPTION(FSO_USE_LUAJIT "Use LuaJIT for Lua scripting, needs a working internet connection!" OFF)

OPTION(FSO_USE_OPENALSOFT "Download and build OpenAL Soft instead of using the system libraries" OFF)

OPTION(FSO_FATAL_WARNINGS "Determines if warnings in the build are considered fatal errors, primarily used for CI" OFF)

SET(FSO_FREESPACE_PATH "${CMAKE_INSTALL_PREFIX}" CACHE FILEPATH "The path of the FreeSpace directory you want to use. Please note that you will have to change CMAKE_INSTALL_PREFIX if you change this at some point.")

SET(FSO_RUN_ARGUMENTS "" CACHE STRING "Additional arguments passed to a generated executable when run with the generated build files.")

option(FSO_INSTALL_DEBUG_FILES "Install some debug files (currently only PDB files on windows)" OFF)

option(ENABLE_COTIRE "Enable cotire for faster compilation. Enabled by default." ON)

option(FSO_RELEASE_LOGGING "Enable logging output for release builds" OFF)

OPTION(FSO_BUILD_WITH_FFMPEG "Enable the usage of FFmpeg for sound and custscenes" ON)

OPTION(FSO_BUILD_WITH_OPENGL "Enable compilation of the OpenGL renderer" ON)
OPTION(FSO_BUILD_WITH_OPENGL_DEBUG "Enables debug option for OpenGL" OFF)

OPTION(FSO_BUILD_WITH_VULKAN "Enable compilation of the Vulkan renderer" OFF)

OPTION(FSO_BUILD_WITH_OPENXR_DEBUG "Enables debug option for OpenXR" OFF)

MARK_AS_ADVANCED(FORCE FSO_CMAKE_DEBUG)
MARK_AS_ADVANCED(FORCE FSO_BUILD_INCLUDED_LIBS)
MARK_AS_ADVANCED(FORCE FSO_USE_OPENALSOFT)
MARK_AS_ADVANCED(FORCE FSO_USE_LUAJIT)
MARK_AS_ADVANCED(FORCE FSO_DEVELOPMENT_MODE)
MARK_AS_ADVANCED(FORCE FSO_FATAL_WARNINGS)
mark_as_advanced(FORCE FSO_INSTALL_DEBUG_FILES)
mark_as_advanced(FORCE ENABLE_COTIRE)
mark_as_advanced(FORCE FSO_RELEASE_LOGGING)
mark_as_advanced(FORCE FSO_BUILD_WITH_FFMPEG)
mark_as_advanced(FORCE FSO_BUILD_WITH_OPENGL)
mark_as_advanced(FORCE FSO_BUILD_WITH_OPENGL_DEBUG)
mark_as_advanced(FORCE FSO_BUILD_WITH_VULKAN)
mark_as_advanced(FORCE FSO_BUILD_WITH_OPENXR_DEBUG)

# Include cotire file from https://github.com/sakra/cotire/
include(cotire)

INCLUDE(globals)
INCLUDE(toolchain)
INCLUDE(platforms)
include(version)

INCLUDE(headers)

SET(GENERATED_SOURCE_DIR ${CMAKE_CURRENT_BINARY_DIR}/generated_source)

include(generateHeaders)

if(FSO_BUILD_APPIMAGE)
	include(appimage)
endif()

include(clang-tidy)

# This includes source code for some tools, either used in the build or also for something else
ADD_SUBDIRECTORY(tools)

ADD_SUBDIRECTORY(lib)

ADD_SUBDIRECTORY(parsers)

ADD_SUBDIRECTORY(code)

ADD_SUBDIRECTORY(freespace2)

IF(FSO_BUILD_FRED2)
	ADD_SUBDIRECTORY(fred2)
ENDIF(FSO_BUILD_FRED2)

IF(FSO_BUILD_QTFRED)
	ADD_SUBDIRECTORY(qtfred)
ENDIF()

if(FSO_BUILD_TESTS)
	add_subdirectory(test)
endif()

if ("${CMAKE_VERSION}" VERSION_GREATER "3.5")
	# Default to using Freespace2 as startup project if CMake supports it.
	set_property(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT Freespace2)
endif()

IF(MSVC_USE_RUNTIME_DLL)
	SET(CMAKE_INSTALL_SYSTEM_RUNTIME_DESTINATION "${BINARY_DESTINATION}")

	IF(FSO_BUILD_FRED2)
		SET(CMAKE_INSTALL_MFC_LIBRARIES ON)
	ENDIF(FSO_BUILD_FRED2)

	INCLUDE(InstallRequiredSystemLibraries)
ENDIF(MSVC_USE_RUNTIME_DLL)

include(package)

include(doxygen)

# Print used options to log
IF(WIN32 OR APPLE)
	message(STATUS "Using text to speech: ${FSO_USE_SPEECH}")
ENDIF()
IF (WIN32)
	message(STATUS "Using voice recogition: ${FSO_USE_VOICEREC}")
	message(STATUS "Building FRED2: ${FSO_BUILD_FRED2}")
elseif(UNIX)
	message(STATUS "Building AppImage: ${FSO_BUILD_APPIMAGE}")
ENDIF()
message(STATUS "Building FSO tools: ${FSO_BUILD_TOOLS}")
message(STATUS "Building qtFRED: ${FSO_BUILD_QTFRED}")
message(STATUS "Fatal warnings: ${FSO_FATAL_WARNINGS}")
message(STATUS "Release logging: ${FSO_RELEASE_LOGGING}")
message(STATUS "With FFmpeg: ${FSO_BUILD_WITH_FFMPEG}")
message(STATUS "With OpenGL: ${FSO_BUILD_WITH_OPENGL}")
message(STATUS "With Vulkan: ${FSO_BUILD_WITH_VULKAN}")

=== Build/CMakeLists.txt ===
#===================================
# Build script for libRocket =======
#===================================

if(APPLE)
	# This has to be before most other options so CMake properly handles the 
	# compiler variables, it MUST bebefore the project() definition
	if(IOS_PLATFORM)
		set(CMAKE_TOOLCHAIN_FILE cmake/Platform/iOS.cmake)
	endif(IOS_PLATFORM)

	option(BUILD_UNIVERSAL_BINARIES "Build universal binaries for all architectures supported" ON)
	if (NOT CMAKE_OSX_ARCHITECTURES AND BUILD_UNIVERSAL_BINARIES)
		if(IOS)
			# set the architecture for iOS 
			if (${IOS_PLATFORM} STREQUAL "OS")
				set (IOS_ARCH armv6 armv7 armv7s arm64)
				set (CMAKE_OSX_ARCHITECTURES ${IOS_ARCH} CACHE string  "Build architecture for iOS")
			else (${IOS_PLATFORM} STREQUAL "OS")
				set (IOS_ARCH i386 x86_64)
				set (CMAKE_OSX_ARCHITECTURES ${IOS_ARCH} CACHE string  "Build architecture for iOS Simulator")
			endif (${IOS_PLATFORM} STREQUAL "OS")

		else(IOS)
			# set the architectures for OS X
			set (OSXI_ARCH i386 x86_64)
			set (CMAKE_OSX_ARCHITECTURES ${OSXI_ARCH} CACHE string  "Build architecture for OS X universal binaries")		
		endif(IOS)
	endif (NOT CMAKE_OSX_ARCHITECTURES AND BUILD_UNIVERSAL_BINARIES)
endif(APPLE)

# We use the new OSX_ARCHITECTURES property
# and GNUInstallDirs module
cmake_minimum_required(VERSION 2.8.5)

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0015 NEW)
endif(COMMAND cmake_policy)

# Enable the use of MACOSX_RPATH by default for CMake v3.0+; this effectively 
# allows plug 'n' play functionality, so to speak -- the resulting shared 
# library files can simply be copied over into the end-user's application 
# bundle or framework bundle. No mucking around with install_name_tool.
#
# 	See also: 
# cmake --help-policy cmp0042
# http://www.kitware.com/blog/home/post/510
if(POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW)
endif(POLICY CMP0042)

project(libRocket C CXX)

# paths
include(GNUInstallDirs)

set(LIBROCKET_VERSION_MAJOR 1)
set(LIBROCKET_VERSION_MINOR 3)
set(LIBROCKET_VERSION_PATCH 0)
set(LIBROCKET_VERSION_TWEAK 0)
set(PROJECT_VERSION ${LIBROCKET_VERSION_MAJOR}.${LIBROCKET_VERSION_MINOR}.${LIBROCKET_VERSION_PATCH}.${LIBROCKET_VERSION_TWEAK})

# Search in the 'cmake' directory for additional CMake modules.
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

# Old versions of CMake need some updated Modules, but we don't want
# to override newer versions of CMake which have working versions
if(CMAKE_MAJOR_VERSION LESS 3)
	list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/v2fixes)
endif()

#===================================
# Environment tests ================
#===================================

include(TestForANSIForScope)
include(TestForANSIStreamHeaders)
include(TestForSTDNamespace)

#===================================
# Provide hints as to where depends=
# might be found                   =
#===================================

if(NOT DEFINED ENV{FREETYPE_DIR})
	set(ENV{FREETYPE_DIR} "${PROJECT_SOURCE_DIR}/../Dependencies")
endif()

#if(NOT DEFINED ENV{Boost_DIR})
#	set(ENV{Boost_DIR} "${PROJECT_SOURCE_DIR}/../Dependencies")
#endif()
if(NOT DEFINED ENV{BOOST_ROOT})
	set(ENV{BOOST_ROOT} "${PROJECT_SOURCE_DIR}/../Dependencies/boost")
endif()

if(NOT DEFINED ENV{LUA_DIR})
	set(ENV{LUA_DIR} "${PROJECT_SOURCE_DIR}/../Dependencies")
endif()

if(NOT DEFINED ENV{SDL2DIR})
	set(ENV{SDL2DIR} "${PROJECT_SOURCE_DIR}/../Dependencies")
endif()

if(NOT DEFINED ENV{SDL2_IMAGE_DIR})
	set(ENV{SDL2_IMAGE_DIR} "${PROJECT_SOURCE_DIR}/../Dependencies")
endif()

if(NOT DEFINED ENV{SFML_ROOT})
	set(ENV{SFML_ROOT} "${PROJECT_SOURCE_DIR}/../Dependencies")
endif()

#===================================
# Plaform specific global hacks ====
#===================================

if(APPLE)
	# Disables naked builtins from AssertMacros.h which
	# This prevents naming collisions such as those from the check()
	# function macro with LuaType::check
	add_definitions(-D__ASSERT_MACROS_DEFINE_VERSIONS_WITHOUT_UNDERSCORES=0)
endif(APPLE)

#===================================
# Build options ====================
#===================================

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif()

if(NOT IOS)
	option(BUILD_SHARED_LIBS "Build shared libraries" ON)
endif(NOT IOS)

option(BUILD_PYTHON_BINDINGS "Build python bindings" OFF)
option(BUILD_LUA_BINDINGS "Build Lua bindings" OFF)

if(APPLE)
	option(BUILD_FRAMEWORK "Build Framework bundle for OSX" OFF)
endif()

option(BUILD_SAMPLES "Build samples" OFF)
if(WIN32)
	option(SKIP_DIRECTX_SAMPLES "Skip build of all DirectX related samples.  Only applies if BUILD_SAMPLES is ON" OFF)
	option(SKIP_DIRECTX9_SAMPLE "Skip build of DirectX 9 related sample.  Only applies if BUILD_SAMPLES is ON and SKIP_DIRECTX_SAMPLES is OFF" OFF)
	option(SKIP_DIRECTX10_SAMPLE "Skip build of DirectX 10 related sample.  Only applies if BUILD_SAMPLES is ON and SKIP_DIRECTX_SAMPLES is OFF" OFF)
endif()

if(APPLE)
	if(IOS)
		if(BUILD_SHARED_LIBS)
			message(FATAL_ERROR "BUILD_SHARED_LIBS must be OFF for iOS builds.  iOS does not support shared libraries.")
		endif(BUILD_SHARED_LIBS)
	endif(IOS)

	if(BUILD_FRAMEWORK)
		if(NOT "${CMAKE_GENERATOR}" STREQUAL "Xcode")
			message(FATAL_ERROR "You should use Xcode generator with BUILD_FRAMEWORK enabled")
		endif()
		if(NOT BUILD_SHARED_LIBS)
			message(FATAL_ERROR "BUILD_SHARED_LIBS must be ON with BUILD_FRAMEWORK enabled")
		endif()
	endif()
else(APPLE)
	if(BUILD_FRAMEWORK)
		message(FATAL_ERROR "BUILD_FRAMEWORK is only supported on Mac OS X with the Xcode generator")
	endif()
endif(APPLE)

if(NOT BUILD_SHARED_LIBS)
	add_definitions(-DROCKET_STATIC_LIB)
endif()

#on windows, check for VC10 and fix the multiple compile target issue.
IF(WIN32)
  if(MSVC)
    if(${MSVC_VERSION} STREQUAL 1600 OR ${MSVC_VERSION} STRGREATER 1600)
      message("Visual Studio 2010 (${MSVC_VERSION}) build fix at play (/FORCE:MULTIPLE)")
      set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /FORCE:MULTIPLE")
    endif()
  endif() 
ENDIF(WIN32)


#===================================
# Find dependencies ================
#===================================

# FreeType
if(CMAKE_MAJOR_VERSION LESS 3)
	# Freetype changed the layout of its header files, we  need to use 
	# the FindFreetype module from cmake v3 at least, included here
	find_package(Freetype-v2fix REQUIRED)	
else()
	find_package(Freetype REQUIRED)	
endif()

if(FREETYPE_FOUND)
		include_directories(${FREETYPE_INCLUDE_DIRS})
		link_directories(${FREETYPE_LINK_DIRS})
		list(APPEND CORE_LINK_LIBS ${FREETYPE_LIBRARY})
endif()
mark_as_advanced(FREETYPE_INCLUDE_DIRS FREETYPE_LIBRARY FREETYPE_LINK_DIRECTORIES)

# Boost and Python
if(BUILD_PYTHON_BINDINGS)
    find_package(PythonInterp 3 REQUIRED)
    find_package(PythonLibs 3 REQUIRED)
    execute_process(
        COMMAND ${PYTHON_EXECUTABLE} -c "from distutils import sysconfig; print(sysconfig.get_python_lib(1,0,prefix=''))"
        OUTPUT_VARIABLE PYTHON_INSTDIR
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    if(PYTHONLIBS_FOUND)
        include_directories(${PYTHON_INCLUDE_DIR})
    endif()

    #set(Boost_USE_STATIC_LIBS OFF)
    #set(Boost_USE_MULTITHREADED ON)
    find_package(Boost 1.40.0 COMPONENTS python REQUIRED)
    if(Boost_FOUND)
        include_directories(${Boost_INCLUDE_DIR})
        list(APPEND PY_BINDINGS_LINK_LIBS ${PYTHON_LIBRARY} ${Boost_LIBRARIES})
    endif()

endif()

#Lua
if(BUILD_LUA_BINDINGS)
    if(CMAKE_MAJOR_VERSION LESS 3)
        find_package(Lua-v2fix)
    else()
        find_package(Lua)
    endif()
    if(LUA_FOUND)
        include_directories(${LUA_INCLUDE_DIR})
        list(APPEND LUA_BINDINGS_LINK_LIBS ${LUA_LIBRARIES})
    endif()
endif()


#===================================
# Setup paths ======================
#===================================

set(PROJECT_SOURCE_DIR ${PROJECT_SOURCE_DIR}/..)

include_directories(
    ${PROJECT_SOURCE_DIR}/Include
)

# Include list of source files
include(FileList)

if(NOT BUILD_FRAMEWORK)
#===================================
# Build libraries ==================
#===================================

set(LIBRARIES Core Controls Debugger)

foreach(library ${LIBRARIES})
    set(NAME Rocket${library})

    add_library(${NAME}
                        ${${library}_HDR_FILES}
                        ${${library}_PUB_HDR_FILES}
                        ${MASTER_${library}_PUB_HDR_FILES}
			${${library}_SRC_FILES}
    )

    set_target_properties(${NAME} PROPERTIES
                           VERSION ${PROJECT_VERSION}
                           SOVERSION ${LIBROCKET_VERSION_MAJOR}
    )
    
    install(TARGETS ${NAME}
            EXPORT libRocketTargets
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    )

    set(ROCKET_EXPORTED_TARGETS ${ROCKET_EXPORTED_TARGETS} ${NAME})
endforeach(library)
else(NOT BUILD_FRAMEWORK)
	#===================================
	# Build combined Framework =========
	#===================================

	set(NAME Rocket)

	set(MASTER_PUB_HDR_FILES
		${MASTER_Core_PUB_HDR_FILES}
		${MASTER_Controls_PUB_HDR_FILES}
		${MASTER_Debugger_PUB_HDR_FILES}
	)

	add_library(${NAME}
		${Core_HDR_FILES}
		${MASTER_Core_PUB_HDR_FILES}
		${Core_PUB_HDR_FILES}
		${Core_SRC_FILES}
		${Controls_HDR_FILES}
		${MASTER_Controls_PUB_HDR_FILES}
		${Controls_PUB_HDR_FILES}
		${Controls_SRC_FILES}
		${Debugger_HDR_FILES}
		${MASTER_Debugger_PUB_HDR_FILES}
		${Debugger_PUB_HDR_FILES}
		${Debugger_SRC_FILES}
	)

	set_target_properties(${NAME} PROPERTIES
		VERSION ${PROJECT_VERSION}
		SOVERSION ${LIBROCKET_VERSION_MAJOR}
	)

		set_property(SOURCE ${MASTER_PUB_HDR_FILES}
			PROPERTY MACOSX_PACKAGE_LOCATION Headers
		)
		set_property(SOURCE ${Core_PUB_HDR_FILES}
			PROPERTY MACOSX_PACKAGE_LOCATION Headers/Core
		)
		set_property(SOURCE ${Controls_PUB_HDR_FILES}
			PROPERTY MACOSX_PACKAGE_LOCATION Headers/Controls
		)
		set_property(SOURCE ${Debugger_PUB_HDR_FILES}
			PROPERTY MACOSX_PACKAGE_LOCATION Headers/Debugger
		)
		set_target_properties(${NAME} PROPERTIES
			FRAMEWORK TRUE
			FRAMEWORK_VERSION ${PROJECT_VERSION}
			MACOSX_FRAMEWORK_IDENTIFIER com.librocketb.${NAME}
			MACOSX_FRAMEWORK_SHORT_VERSION_STRING ${LIBROCKET_VERSION_MAJOR}.${LIBROCKET_VERSION_MINOR}.${LIBROCKET_VERSION_PATCH}.${LIBROCKET_VERSION_TWEAK}
			MACOSX_FRAMEWORK_BUNDLE_VERSION ${PROJECT_VERSION}
			XCODE_ATTRIBUTE_INSTALL_PATH "@rpath"
			PUBLIC_HEADER ${MASTER_PUB_HDR_FILES}
		)

    install(TARGETS ${NAME}
            EXPORT libRocketTargets
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            FRAMEWORK DESTINATION Library/Frameworks
    )

    set(ROCKET_EXPORTED_TARGETS ${ROCKET_EXPORTED_TARGETS} ${NAME})
endif(NOT BUILD_FRAMEWORK)

# Build python bindings
if(BUILD_PYTHON_BINDINGS)
    set(LIBRARIES core controls)

    foreach(library ${LIBRARIES})
        set(NAME _rocket${library})

        add_library(${NAME} MODULE ${Py${library}_SRC_FILES}
                            ${Py${library}_HDR_FILES}
                            ${Py${library}_PUB_HDR_FILES}
        )

        set_target_properties(${NAME} PROPERTIES PREFIX "")

        install(TARGETS ${NAME}
                EXPORT libRocketTargets
                LIBRARY DESTINATION ${PYTHON_INSTDIR}
        )
 
    endforeach(library)
endif()

# Build Lua bindings
if(BUILD_LUA_BINDINGS)
    set(LIBRARIES Core Controls)

    foreach(library ${LIBRARIES})
        set(NAME Rocket${library}Lua)

        add_library(${NAME} ${Lua${library}_SRC_FILES}
                            ${Lua${library}_HDR_FILES}
                            ${Lua${library}_PUB_HDR_FILES}
        )

        set_target_properties(${NAME} PROPERTIES

=== code/CMakeLists.txt ===

include(util)

INCLUDE(source_groups.cmake)
INCLUDE(voice_rec.cmake)

ADD_LIBRARY(code STATIC ${source_files} ${VOICE_REC_FILES})

target_compile_features(code PUBLIC cxx_std_11)

if (MSVC)
	target_compile_definitions(code PUBLIC "PDB_DEBUGGING=1")
endif(MSVC)

TARGET_INCLUDE_DIRECTORIES(code PUBLIC ${CODE_HEADERS})
TARGET_INCLUDE_DIRECTORIES(code PUBLIC ${FREESPACE_HEADERS})

TARGET_INCLUDE_DIRECTORIES(code PUBLIC ${GENERATED_SOURCE_DIR})
TARGET_INCLUDE_DIRECTORIES(code PUBLIC ${GENERATED_SOURCE_DIR}/code)

if (FSO_BUILD_WITH_OPENGL)
	target_link_libraries(code PUBLIC OpenGL)
	if(FSO_BUILD_WITH_OPENGL_DEBUG)
		add_definitions(-DFS_OPENGL_DEBUG)
	endif()
endif()

if(FSO_BUILD_WITH_OPENXR_DEBUG)
	add_definitions(-DFS_OPENXR_DEBUG)
endif()

TARGET_LINK_LIBRARIES(code PUBLIC openal)
TARGET_LINK_LIBRARIES(code PUBLIC ${LUA_LIBS})
TARGET_LINK_LIBRARIES(code PUBLIC ${PNG_LIBS})
TARGET_LINK_LIBRARIES(code PUBLIC ${JPEG_LIBS})
TARGET_LINK_LIBRARIES(code PUBLIC lz4)

TARGET_LINK_LIBRARIES(code PUBLIC sdl2)

if (FSO_BUILD_WITH_FFMPEG)
	TARGET_LINK_LIBRARIES(code PUBLIC ffmpeg)
endif()

TARGET_LINK_LIBRARIES(code PUBLIC utfcpp)

TARGET_LINK_LIBRARIES(code PUBLIC platform)
TARGET_LINK_LIBRARIES(code PUBLIC compiler)

target_link_libraries(code PUBLIC md5)

target_link_libraries(code PUBLIC discord-rpc)

target_link_libraries(code PUBLIC libRocket)

target_link_libraries(code PUBLIC pcp)

target_link_libraries(code PUBLIC parsers)

target_link_libraries(code PUBLIC mdns)

enable_clang_tidy(code)

IF (FSO_USE_SPEECH)
	find_package(Speech REQUIRED)
	target_link_libraries(code PUBLIC speech)
ENDIF(FSO_USE_SPEECH)

TARGET_LINK_LIBRARIES(code PUBLIC jansson)

target_link_libraries(code PUBLIC variant)

target_link_libraries(code PUBLIC any)

target_link_libraries(code PUBLIC optional)

target_link_libraries(code PUBLIC anl)

target_link_libraries(code PUBLIC hidapi::hidapi)

target_link_libraries(code PUBLIC imgui)

IF(NOT APPLE)
	target_link_libraries(code PUBLIC OpenXR::openxr_loader)
	target_include_directories(code PUBLIC OpenXR::Headers)
ENDIF()
IF(CMAKE_SYSTEM_NAME MATCHES "Linux")
	# On Linux, we need to access X11 window data.
	# On Windows, SDL already provides everything, so no need to do anything
	find_package(X11)
	target_link_libraries(code PUBLIC ${X11_LIBRARIES})
ENDIF()

# Headers for standalone "gui" on UNIX
IF(UNIX)
	TARGET_LINK_LIBRARIES(code PUBLIC ${MONGOOSE_LIBS})
ENDIF(UNIX)

IF(FSO_BUILD_TOOLS)
	ADD_SUBDIRECTORY(cfilearchiver)

	ADD_SUBDIRECTORY(cfileextractor)
ENDIF(FSO_BUILD_TOOLS)

if (FSO_RELEASE_LOGGING)
	target_compile_definitions(code PUBLIC SCP_RELEASE_LOGGING)
endif()

if (FSO_BUILD_WITH_FFMPEG)
	target_compile_definitions(code PUBLIC WITH_FFMPEG)
endif()
if (FSO_BUILD_WITH_OPENGL)
	target_compile_definitions(code PUBLIC WITH_OPENGL)
endif()
if (FSO_BUILD_WITH_VULKAN)
	find_package(Vulkan REQUIRED)
	if (Vulkan_FOUND)
		target_compile_definitions(code PUBLIC WITH_VULKAN)
		target_link_libraries(code PRIVATE Vulkan::Vulkan)

		target_compile_definitions(code PUBLIC WITH_VULKAN VULKAN_HPP_DISPATCH_LOADER_DYNAMIC=1 VK_NO_PROTOTYPES)
	else()
		message(WARNING "FSO_BUILD_WITH_VULKAN was set, but the package was unable to be found. Forcing OFF.")
		set(FSO_BUILD_WITH_VULKAN OFF CACHE BOOL "Enable compilation of the Vulkan renderer" FORCE)
	endif()
endif()

include(shaders.cmake)

target_embed_files(code FILES ${default_files_files} RELATIVE_TO "def_files")

handle_embedded_files(code)

set_precompiled_header(code "${CMAKE_CURRENT_SOURCE_DIR}/prefix_header.h")

# Ensure that Xcode generates debug symbols on macOS for Debug builds
set_target_properties(code PROPERTIES XCODE_ATTRIBUTE_GCC_GENERATE_DEBUGGING_SYMBOLS[variant=Debug] "YES")
set_target_properties(code PROPERTIES XCODE_ATTRIBUTE_COPY_PHASE_STRIP[variant=Debug] "NO")
set_target_properties(code PROPERTIES XCODE_ATTRIBUTE_STRIP_INSTALLED_PRODUCT[variant=Debug] "NO")
set_target_properties(code PROPERTIES XCODE_ATTRIBUTE_GCC_SYMBOLS_PRIVATE_EXTERN[variant=Debug] "NO")

# Prevent GCC warnings in third-party BitOp... see GitHub #4366
suppress_file_warnings(scripting/lua/bitop/bit.c)

=== fred2/CMakeLists.txt ===

FIND_PACKAGE(MFC)

if (NOT MFC_FOUND)
	message(STATUS "MFC could not be found, not building FRED")
	return()
endif()

set(FRED2_SOURCES
	altshipclassdlg.cpp
	altshipclassdlg.h
	fictionviewerdlg.cpp
	fictionviewerdlg.h
	addvariabledlg.cpp
	addvariabledlg.h
	addmodifycontainerdlg.cpp
	addmodifycontainerdlg.h
	adjustgriddlg.cpp
	adjustgriddlg.h
	asteroideditordlg.cpp
	asteroideditordlg.h
	bgbitmapdlg.cpp
	bgbitmapdlg.h
	briefingeditordlg.cpp
	briefingeditordlg.h
	calcrelativecoordsdlg.cpp
	calcrelativecoordsdlg.h
	campaigneditordlg.cpp
	campaigneditordlg.h
	campaignfilelistbox.cpp
	campaignfilelistbox.h
	campaigntreeview.cpp
	campaigntreeview.h
	campaigntreewnd.cpp
	campaigntreewnd.h
	checkboxlistdlg.cpp
	checkboxlistdlg.h
	cmdbrief.cpp
	cmdbrief.h
	createwingdlg.cpp
	createwingdlg.h
	customdatadlg.cpp
	customdatadlg.h
	customstringsdlg.cpp
	customstringsdlg.h
	customwingnames.cpp
	customwingnames.h
	debriefingeditordlg.cpp
	debriefingeditordlg.h
	dumpstats.cpp
	dumpstats.h
	editcontainernamedlg.cpp
	editcontainernamedlg.h
	editor.h
	eventeditor.cpp
	eventeditor.h
	fred.cpp
	fred.h
	freddoc.cpp
	freddoc.h
	fredrender.cpp
	fredrender.h
	fredstubs.cpp
	fredview.cpp
	fredview.h
	grid.cpp
	grid.h
	ignoreordersdlg.cpp
	ignoreordersdlg.h
	initialships.cpp
	initialships.h
	initialstatus.cpp
	initialstatus.h
	jumpnodedlg.cpp
	jumpnodedlg.h
	listitemchooser.cpp
	listitemchooser.h
	mainfrm.cpp
	mainfrm.h
	management.cpp
	management.h
	messageeditordlg.cpp
	messageeditordlg.h
	missioncutscenesdlg.cpp
	missioncutscenesdlg.h
	missiongoalsdlg.cpp
	missiongoalsdlg.h
	missionnotesdlg.cpp
	missionnotesdlg.h
	missionsave.cpp
	missionsave.h
	modifyvariabledlg.cpp
	modifyvariabledlg.h
	musicplayerdlg.cpp
	musicplayerdlg.h
	operatorargtypeselect.cpp
	operatorargtypeselect.h
	OperatorComboBox.cpp
	OperatorComboBox.h
	orienteditor.cpp
	orienteditor.h
	playerstarteditor.cpp
	playerstarteditor.h
	prefsdlg.cpp
	prefsdlg.h
	reinforcementeditordlg.cpp
	reinforcementeditordlg.h
	resource.h
	restrictpaths.cpp
	restrictpaths.h
	setglobalshipflags.cpp
	setglobalshipflags.h
	sexp_tree.cpp
	sexp_tree.h
	shieldsysdlg.cpp
	shieldsysdlg.h
	ship_select.cpp
	ship_select.h
	shipchecklistbox.cpp
	shipchecklistbox.h
	shipclasseditordlg.cpp
	shipclasseditordlg.h
	shipeditordlg.cpp
	shipeditordlg.h
	shipflagsdlg.cpp
	shipflagsdlg.h
	shipgoalsdlg.cpp
	shipgoalsdlg.h
	shipspecialdamage.cpp
	shipspecialdamage.h
	shipspecialhitpoints.cpp
	shipspecialhitpoints.h
	shiptexturesdlg.cpp
	shiptexturesdlg.h
	soundenvironmentdlg.cpp
	soundenvironmentdlg.h
	starfieldeditor.cpp
	starfieldeditor.h
	stdafx.cpp
	stdafx.h
	textviewdlg.cpp
	textviewdlg.h
	voiceactingmanager.cpp
	voiceactingmanager.h
	volumetricsdlg.cpp
	volumetricsdlg.h
	warpparamsdlg.cpp
	warpparamsdlg.h
	waypointpathdlg.cpp
	waypointpathdlg.h
	weaponeditordlg.cpp
	weaponeditordlg.h
	wing.cpp
	wing.h
	wing_editor.cpp
	wing_editor.h
	MFCGraphicsOperations.cpp
	MFCGraphicsOperations.h
	fred.rc
	version.rc2
)

set_source_files_properties(fred.rc PROPERTIES
	LANGUAGE RC
)

IF(MSVC_USE_RUNTIME_DLL)
	set(CMAKE_MFC_FLAG 2)
ELSE(MSVC_USE_RUNTIME_DLL)
	set(CMAKE_MFC_FLAG 1)
ENDIF(MSVC_USE_RUNTIME_DLL)

IF(MSVC60)
	link_directories(${STLPORT_INCLUDE_LIB_DIRS})
ENDIF(MSVC60)

add_executable(FRED2 WIN32 ${FRED2_SOURCES})

SET_TARGET_PROPERTIES(FRED2 PROPERTIES OUTPUT_NAME "fred2_open_${FSO_BINARY_SUFFIX}")

target_compile_definitions(FRED2 PUBLIC FRED NO_WARN_MBCS_MFC_DEPRECATION)

if (MSVC)
	set_target_properties(FRED2 PROPERTIES LINK_FLAGS "/FORCE:MULTIPLE")
endif()

INCLUDE_DIRECTORIES(${FREESPACE_HEADERS})
INCLUDE_DIRECTORIES(${GENERATED_SOURCE_DIR})

IF(USE_STLPORT)
	INCLUDE_DIRECTORIES(BEFORE SYSTEM ${STLPORT_INCLUDE_DIRS})
ENDIF(USE_STLPORT)

FIND_PACKAGE(OpenGL REQUIRED)
target_link_libraries(FRED2 PUBLIC "${OPENGL_LIBRARY}")

TARGET_LINK_LIBRARIES(FRED2 PUBLIC code) # This will also link all dependencies of code
TARGET_LINK_LIBRARIES(FRED2 PUBLIC "$<$<NOT:$<CONFIG:Release>>:nafxcwd.lib>")
TARGET_LINK_LIBRARIES(FRED2 PUBLIC "$<$<CONFIG:Release>:nafxcw.lib>")

target_link_libraries(FRED2 PUBLIC glad_wgl)

enable_clang_tidy(FRED2)

INSTALL(
	TARGETS FRED2
	RUNTIME DESTINATION ${BINARY_DESTINATION}
)
if (FSO_INSTALL_DEBUG_FILES)
	if (MSVC)
		install(FILES "$<TARGET_PDB_FILE:FRED2>"
				DESTINATION ${BINARY_DESTINATION}
				OPTIONAL)
	endif()
endif()

INCLUDE(util)
COPY_FILES_TO_TARGET(FRED2)

include(CreateLaunchers)
create_target_launcher(FRED2
	WORKING_DIRECTORY ${FSO_FREESPACE_PATH}
	ARGS ${FSO_RUN_ARGUMENTS})

=== freespace2/CMakeLists.txt ===


SET(FREESPACE_SRC freespace.cpp
				levelpaging.cpp
				freespace.h
				levelpaging.h
				SDLGraphicsOperations.cpp
				SDLGraphicsOperations.h)

IF(FSO_BUILD_PACKAGE)
	IF(FSO_INSTRUCTION_SET STREQUAL "SSE2" OR FSO_INSTRUCTION_SET STREQUAL "AVX")
		SET(FSO_INSTALLER_ICON "${CMAKE_CURRENT_SOURCE_DIR}/V_sse.ico" CACHE FILEPATH "The path of the installer icon")
	ELSE()
		SET(FSO_INSTALLER_ICON "${CMAKE_CURRENT_SOURCE_DIR}/V_app.ico" CACHE FILEPATH "The path of the installer icon")
	ENDIF()
ENDIF(FSO_BUILD_PACKAGE)

IF(MSVC60)
	link_directories(${STLPORT_INCLUDE_LIB_DIRS})
ENDIF(MSVC60)

ADD_EXECUTABLE(Freespace2 ${EXE_GUI_TYPE} ${FREESPACE_SRC})

include(resources.cmake)

SET_TARGET_PROPERTIES(Freespace2 PROPERTIES OUTPUT_NAME "fs2_open_${FSO_BINARY_SUFFIX}")

TARGET_LINK_LIBRARIES(Freespace2 code)
TARGET_LINK_LIBRARIES(Freespace2 platform)
TARGET_LINK_LIBRARIES(Freespace2 compiler)

IF(WIN32)
	# Link sdl main only here as it interferes with fred
	TARGET_LINK_LIBRARIES(Freespace2 sdlmain)
ENDIF(WIN32)

if(FSO_BUILD_WITH_OPENGL_DEBUG)
	add_definitions(-DFS_OPENGL_DEBUG)
endif()

IF(FSO_USE_VOICEREC)
	ADD_DEFINITIONS(-DFS2_VOICER)
ENDIF(FSO_USE_VOICEREC)

INCLUDE_DIRECTORIES(${FREESPACE_HEADERS})
INCLUDE_DIRECTORIES(${GENERATED_SOURCE_DIR})

IF(USE_STLPORT)
	INCLUDE_DIRECTORIES(BEFORE SYSTEM ${STLPORT_INCLUDE_DIRS})
ENDIF(USE_STLPORT)

# Add install script to copy the executable to the FreeSpace path if possible and wanted
INSTALL(
	TARGETS Freespace2
	RUNTIME DESTINATION ${BINARY_DESTINATION} COMPONENT "Freespace2"
	BUNDLE DESTINATION ${BINARY_DESTINATION} COMPONENT "Freespace2"
)
if (FSO_INSTALL_DEBUG_FILES)
	if (MSVC)
		install(FILES "$<TARGET_PDB_FILE:Freespace2>"
				DESTINATION ${BINARY_DESTINATION}
				OPTIONAL)
	endif()
endif()

enable_clang_tidy(Freespace2)

INCLUDE(util)
COPY_FILES_TO_TARGET(Freespace2)

include(CreateLaunchers)
create_target_launcher(Freespace2
	WORKING_DIRECTORY ${FSO_FREESPACE_PATH}
	ARGS ${FSO_RUN_ARGUMENTS})

separate_arguments(RUN_ARGS_LIST UNIX_COMMAND "${FSO_RUN_ARGUMENTS}")
message("${FSO_RUN_ARGUMENTS}")
add_custom_target(launch_fso
		COMMAND Freespace2 ${RUN_ARGS_LIST}
		WORKING_DIRECTORY "${FSO_FREESPACE_PATH}"
		COMMENT "Launching FreeSpace"
		VERBATIM)

# Ensure that Xcode generates debug symbols on macOS for Debug builds
set_target_properties(Freespace2 PROPERTIES XCODE_ATTRIBUTE_GCC_GENERATE_DEBUGGING_SYMBOLS[variant=Debug] "YES")
set_target_properties(Freespace2 PROPERTIES XCODE_ATTRIBUTE_COPY_PHASE_STRIP[variant=Debug] "NO")
set_target_properties(Freespace2 PROPERTIES XCODE_ATTRIBUTE_STRIP_INSTALLED_PRODUCT[variant=Debug] "NO")
set_target_properties(Freespace2 PROPERTIES XCODE_ATTRIBUTE_GCC_SYMBOLS_PRIVATE_EXTERN[variant=Debug] "NO")

=== lib/CMakeLists.txt ===

include(prebuilt.cmake)

ADD_SUBDIRECTORY(libjpeg)

ADD_SUBDIRECTORY(zlib)

ADD_SUBDIRECTORY(libpng)

ADD_SUBDIRECTORY(lua)

include(OpenAL.cmake)

if (FSO_BUILD_WITH_OPENGL)
	add_subdirectory(opengl)
endif()

include(SDL2.cmake)

ADD_SUBDIRECTORY(jansson)
# These are only required for the web-ui which is non-Windows
IF(UNIX)
	ADD_SUBDIRECTORY(mongoose)
ENDIF(UNIX)

add_subdirectory(md5)

add_subdirectory(utfcpp)

include(freetype.cmake)

if (FSO_BUILD_WITH_FFMPEG)
	include(FFmpeg.cmake)
endif()

add_subdirectory(discord)

include(libRocket.cmake)

add_subdirectory(libpcp)

include(antlr4.cmake)

include(vulkan.cmake)

add_subdirectory(mdns)

add_subdirectory(variant)

add_subdirectory(any)

add_subdirectory(accidental-noise)

add_subdirectory(optional)

ADD_SUBDIRECTORY(lz4)

set(HIDAPI_WITH_LIBUSB OFF)
set(HIDAPI_WITH_HIDRAW ON)
add_subdirectory(hidapi)

ADD_SUBDIRECTORY(imgui)

if(NOT APPLE)
	add_subdirectory(openxr)
endif()

=== parsers/CMakeLists.txt ===

function(add_parser filename)
    get_filename_component(_name "${filename}" NAME_WE)
    get_filename_component(_absolutePath "${filename}" ABSOLUTE)

    get_filename_component(_directory "${_absolutePath}" DIRECTORY)
    get_filename_component(_directoryName "${_directory}" NAME)

    if (ANTLR_FOUND)
        antlr_target(${_name} "${_absolutePath}"
            VISITOR
            OUTPUT_DIRECTORY "${_directory}/generated")
        target_sources(parsers PRIVATE "${_absolutePath}")
        source_group("${_directoryName}" FILES "${_absolutePath}")
    else()
        # Otherwise we just use the ones that are checked in
        set(ANTLR_${_name}_OUTPUTS
            ${_directory}/generated/${_name}BaseVisitor.cpp
            ${_directory}/generated/${_name}BaseVisitor.h
            ${_directory}/generated/${_name}Lexer.cpp
            ${_directory}/generated/${_name}Lexer.h
            ${_directory}/generated/${_name}Parser.cpp
            ${_directory}/generated/${_name}Parser.h
            ${_directory}/generated/${_name}Visitor.cpp
            ${_directory}/generated/${_name}Visitor.h
        )
    endif()

    target_sources(parsers PRIVATE ${ANTLR_${_name}_OUTPUTS})
    source_group("${_directoryName}\\generated" FILES ${ANTLR_${_name}_OUTPUTS})
endfunction()

add_library(parsers STATIC)

target_link_libraries(parsers PUBLIC antlr4_static)

find_package(ANTLR)

if (ANTLR_FOUND)
    # If we have an ANTLR installation then we can generate new sources
    message(STATUS "Using ANTLR to generate parser")
else()
    message(STATUS "Using generated ANTLR files")
endif()

add_parser(arg_parser/ArgumentList.g4)
add_parser(action_expression/ActionExpression.g4)

target_include_directories(parsers PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}")

suppress_warnings(parsers)

=== test/CMakeLists.txt ===

set(gtest_force_shared_crt "${MSVC_USE_RUNTIME_DLL}" CACHE BOOL "Always use msvcrt.dll" FORCE)

set(GOOGLETEST_VERSION 1.10.0)
add_subdirectory(gtest)

target_compile_definitions(gtest PUBLIC "$<$<CONFIG:FastDebug>:_ITERATOR_DEBUG_LEVEL=0>")

set_target_properties(gtest PROPERTIES FOLDER "3rdparty")

add_subdirectory(src)

=== ci/post/requirements.txt ===
Mako==1.2.2
requests==2.32.0
semantic-version==2.8.5

=== code/cfilearchiver/CMakeLists.txt ===

add_executable(cfilearchiver EXCLUDE_FROM_ALL cfilearchiver.cpp)

ADD_DEFINITIONS(-DNO_SAFE_STRINGS)
include_directories(${CODE_HEADERS})

set_target_properties(cfilearchiver
	PROPERTIES
		FOLDER "FSOTools"
)
TARGET_LINK_LIBRARIES(cfilearchiver PUBLIC sdl2)
TARGET_INCLUDE_DIRECTORIES(cfilearchiver PUBLIC ${GENERATED_SOURCE_DIR})
TARGET_INCLUDE_DIRECTORIES(cfilearchiver PUBLIC ${GENERATED_SOURCE_DIR}/code)

IF(MSVC)
	set_target_properties(cfilearchiver PROPERTIES
		COMPILE_DEFINITIONS_DEBUG "_DEBUG;PDB_DEBUGGING=1"
	)
ENDIF(MSVC)

=== code/cfileextractor/CMakeLists.txt ===

add_executable(cfileextractor EXCLUDE_FROM_ALL cfileextractor.cpp)

ADD_DEFINITIONS(-DNO_SAFE_STRINGS)
include_directories(${CODE_HEADERS})

set_target_properties(cfileextractor
	PROPERTIES
		FOLDER "FSOTools"
)
TARGET_LINK_LIBRARIES(cfileextractor PUBLIC sdl2)
TARGET_INCLUDE_DIRECTORIES(cfileextractor PUBLIC ${GENERATED_SOURCE_DIR})
TARGET_INCLUDE_DIRECTORIES(cfileextractor PUBLIC ${GENERATED_SOURCE_DIR}/code)

IF(MSVC)
	set_target_properties(cfileextractor PROPERTIES
		COMPILE_DEFINITIONS_DEBUG "_DEBUG;PDB_DEBUGGING=1"
	)
ENDIF(MSVC)

=== lib/accidental-noise/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

add_definitions(-DUSETHREAD)

add_library(anl STATIC anl_impl.cpp)
target_link_libraries(anl PUBLIC compiler)
suppress_warnings(anl)

target_include_directories(anl PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}")

=== debian/changelog ===
freespace2 (24.2.0+repack-1) unstable; urgency=medium

  * New upstream release.

 -- Sébastien Noel <sebastien@twolife.be>  Sun, 24 Aug 2025 12:10:14 +0200

=== debian/packages/freespace2-data-gog/debian/changelog ===
freespace2-data-gog (1999-2) UNRELEASED; urgency=medium

  * Verify extracted files, not the archive (Closes: #743067).

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 10 Jul 2016 06:59:09 +1000

=== debian/packages/freespace2-mod-fsport/debian/changelog ===
freespace2-mod-fsport (3.7-1) UNRELEASED; urgency=medium

  * New upstream release [2022].
  * Modernised packaging.

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 29 Dec 2023 20:25:26 +1100

=== debian/packages/freespace2-mod-mediavps/debian/changelog ===
freespace2-mod-mediavps (4.7.3-1) UNRELEASED; urgency=medium

  * New upstream release.

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 09 Aug 2024 14:24:26 +1000

=== debian/control ===
Source: freespace2
Section: non-free/games
Priority: optional
Standards-Version: 4.6.2
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Uploaders: Sébastien Noel <sebastien@twolife.be>
Build-Depends: debhelper-compat (= 13)
    ,quilt
    ,cmake
    ,antlr4
    ,libantlr4-runtime-dev
    ,libavcodec-dev,
    ,libavformat-dev
    ,libavutil-dev
    ,libswscale-dev
    ,libswresample-dev
    ,libfreetype-dev
    ,libgl-dev,
    ,libglu1-mesa-dev,
    ,libhidapi-dev
    ,libimgui-dev
    ,libjansson-dev
    ,libjpeg-dev
    ,liblua5.1-0-dev
    ,libopenal-dev
    ,libopenxr-dev
    ,libpng-dev
    ,libsdl2-dev
    ,libstb-dev
    ,libtheora-dev
    ,libutfcpp-dev
    ,libvorbis-dev
    ,libvulkan-dev
    ,liblz4-dev
    ,libxcb-glx0-dev
    ,zlib1g-dev
Homepage: http://scp.indiegames.us/
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/games-team/freespace2
Vcs-Git: https://salsa.debian.org/games-team/freespace2.git

Package: freespace2
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Recommends: freespace2-launcher, freespace2-data | game-data-packager
           ,freespace2-mod-mediavps
#           ,freespace2-data-gog | freespace2-data-volition
Suggests: joystick
         ,check-dfsg-status
         ,dpkg-dev
Description: open implementation of the Freespace 2 game engine
 FreeSpace is a series of space combat simulation games developed
 by Volition, Inc. and published by Interplay Entertainment.
 The games take place in the 24th century. Mankind, referred to as
 Terrans, has developed means for space traveling, further fueled
 by the discovery of subspace which makes interstellar travel not
 only possible but also fast and easy. As a result the Terrans have
 expanded their territory, eventually encountering another bipedal,
 sentient species; the Vasudans. However, due to cultural differences
 and difficulties in communicating with each other, the Galactic Terran
 Alliance (GTA) and the Parliamentary Vasudan Empire (PVE) end up fighting
 a war that lasts for 14 years.
 .
 Original game files from CD are needed to play this game.

#Package: freespace2-docs
#Architecture: all
#Depends: ${misc:Depends}, libjs-jquery
#Recommends: yelp
#Suggests: www-browser
#Section: doc
#Description: open implementation of the Freespace 2 game engine -- Documentation for developers
# FreeSpace is a series of space combat simulation games developed
# by Volition, Inc. and published by Interplay Entertainment.
# The games take place in the 24th century. Mankind, referred to as
# Terrans, has developed means for space traveling, further fueled
# by the discovery of subspace which makes interstellar travel not
# only possible but also fast and easy. As a result the Terrans have
# expanded their territory, eventually encountering another bipedal,
# sentient species; the Vasudans. However, due to cultural differences
# and difficulties in communicating with each other, the Galactic Terran
# Alliance (GTA) and the Parliamentary Vasudan Empire (PVE) end up fighting
# a war that lasts for 14 years.
# .
# This package provides documentation for developers

=== debian/packages/freespace2-data-volition/debian/control ===
Source: freespace2-data-volition
Section: non-free/games
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@member.fsf.org>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.4
Homepage: http://www.gog.com/gamecard/freespace_2

Package: freespace2-data-volition
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: freespace2
Suggests: freespace2-video
         ,check-dfsg-status
Breaks: freespace2-data-gog
Replaces: freespace2-data-gog
Description: FreeSpace2 - original media files by Volition Inc
 FreeSpace 2 is a 1999 space combat simulation computer game developed
 by Volition, Inc. as the sequel to Descent: FreeSpace – The Great
 War.
 The games take place in the 24th century. Mankind, referred to as
 Terrans, has developed means for space traveling, further fueled
 by the discovery of subspace which makes interstellar travel not
 only possible but also fast and easy. As a result the Terrans have
 expanded their territory, eventually encountering another bipedal,
 sentient species; the Vasudans. However, due to cultural differences
 and difficulties in communicating with each other, the Galactic Terran
 Alliance (GTA) and the Parliamentary Vasudan Empire (PVE) end up fighting
 a war that lasts for 14 years.
 .
 This package provides original game data files from CD that are needed
 to play this game.

=== debian/packages/freespace2-mod-fsport/debian/control ===
Source: freespace2-mod-fsport
Section: non-free/games
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@member.fsf.org>
Build-Depends: debhelper-compat (= 13)
              ,diffutils
              ,dpkg-dev
              ,p7zip-full
              ,wget
Standards-Version: 4.6.2
Homepage: http://fsport.hard-light.net/
Rules-Requires-Root: no

Package: freespace2-mod-fsport
Architecture: all
Depends: ${misc:Depends}
        ,freespace2-mod-fsport-campaign-greatwar
        ,freespace2-mod-fsport-campaign-silentthreat
        ,freespace2-mod-fsport-campaign-awakenings
        ,freespace2-mod-fsport-campaign-cardinalspear
        ,freespace2-mod-fsport-campaign-destinyofpeace
        ,freespace2-mod-fsport-cbani
        ,freespace2-mod-fsport-mediavps
        ,freespace2-mod-fsport-music
        ,freespace2-mod-fsport-video
Suggests: check-dfsg-status
Description: FreeSpace2 - all "fsport" campaigns (metapackage)
 The FreeSpace Port (fsport) is a mod for FreeSpace 2 that allows you to
 play the original Great War and Silent Threat campaigns in the newer
 FS2 engine, as well as specific user-made campaigns such as Silent
 Threat: Reborn. This version of the Port was specifically designed to
 be compatible with retail FreeSpace while still taking advantage of
 the additional features in FreeSpace Open.
 .
 This metapackage depends on all "fsport" campaigns and addons.

Package: freespace2-mod-fsport-campaign-greatwar
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
        ,freespace2-data-gog | freespace2-data-volition
        ,freespace2-mod-mediavps (>= 3.6.12)
        ,freespace2-mod-fsport-mediavps
Recommends: freespace2
           ,freespace2-mod-fsport-cbani
           ,freespace2-mod-fsport-music
           ,freespace2-mod-fsport-video
Suggests: check-dfsg-status
Description: FreeSpace2 - "FreeSpace - The Great War" campaign
 Original "Descent: FreeSpace – The Great War" 1998 campaign by Volition.
 .
 A fourteen-year war between the Terran and Vasudan species leads into
 something far more sinister. This is the story of the Great War.
 .
 The FreeSpace Port (fsport) is a mod for FreeSpace 2 that allows you to
 play the original Great War and Silent Threat campaigns in the newer
 FS2 engine, as well as specific user-made campaigns such as Silent
 Threat: Reborn. This version of the Port was specifically designed to
 be compatible with retail FreeSpace while still taking advantage of
 the additional features in FreeSpace Open.

Package: freespace2-mod-fsport-cbani
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
        ,freespace2-mod-fsport-campaign-greatwar
Recommends: freespace2, freespace2-launcher
Suggests: check-dfsg-status
Enhances: freespace2-mod-fsport-campaign-greatwar
         ,freespace2-mod-fsport-campaign-silentthreat
         ,freespace2-mod-fsport-campaign-awakenings
         ,freespace2-mod-fsport-campaign-cardinalspear
         ,freespace2-mod-fsport-campaign-destinyofpeace
Description: FreeSpace2 - fsport campaigns' (high-resolution CBANIs)
 Community-developed high-resolution command briefing animations (CBANI)
 that appear in the window under the command briefing text.
 .
 The FreeSpace Port (fsport) is a mod for FreeSpace 2 that allows you to
 play the original Great War and Silent Threat campaigns in the newer
 FS2 engine, as well as specific user-made campaigns such as Silent
 Threat: Reborn. This version of the Port was specifically designed to
 be compatible with retail FreeSpace while still taking advantage of
 the additional features in FreeSpace Open.

Package: freespace2-mod-fsport-mediavps
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
        ,freespace2-mod-fsport-campaign-greatwar
Recommends: freespace2-mod-fsport-mediavps-music
           ,freespace2
           ,freespace2-launcher
Suggests: check-dfsg-status
Enhances: freespace2-mod-fsport-campaign-greatwar
         ,freespace2-mod-fsport-campaign-silentthreat
         ,freespace2-mod-fsport-campaign-awakenings
         ,freespace2-mod-fsport-campaign-cardinalspear
         ,freespace2-mod-fsport-campaign-destinyofpeace
Description: FreeSpace2 - fsport campaigns' (high-resolution media)
 Community-developed high-resolution texture maps for "fsport"
 campaigns.
 .
 The FreeSpace Port (fsport) is a mod for FreeSpace 2 that allows you to
 play the original Great War and Silent Threat campaigns in the newer
 FS2 engine, as well as specific user-made campaigns such as Silent
 Threat: Reborn. This version of the Port was specifically designed to
 be compatible with retail FreeSpace while still taking advantage of
 the additional features in FreeSpace Open.

Package: freespace2-mod-fsport-mediavps-music
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: freespace2, freespace2-launcher
Suggests: check-dfsg-status
Enhances: freespace2-mod-fsport-mediavps
Description: FreeSpace2 - fsport campaigns' (high-resolution music)
 Music for "mediavps" high-resolution pack.
 .
 The FreeSpace Port (fsport) is a mod for FreeSpace 2 that allows you to
 play the original Great War and Silent Threat campaigns in the newer
 FS2 engine, as well as specific user-made campaigns such as Silent
 Threat: Reborn. This version of the Port was specifically designed to
 be compatible with retail FreeSpace while still taking advantage of
 the additional features in FreeSpace Open.

Package: freespace2-mod-fsport-music
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
 freespace2-mod-fsport-campaign-greatwar | freespace2-mod-fsport-campaign-silentthreat
Recommends: freespace2, freespace2-launcher
Suggests: check-dfsg-status
Enhances: freespace2-mod-fsport-campaign-greatwar
         ,freespace2-mod-fsport-campaign-silentthreat
Description: FreeSpace2 - fsport campaigns' music
 Music for "Great War" and "Silent Threat" campaigns.
 .
 The FreeSpace Port (fsport) is a mod for FreeSpace 2 that allows you to
 play the original Great War and Silent Threat campaigns in the newer
 FS2 engine, as well as specific user-made campaigns such as Silent
 Threat: Reborn. This version of the Port was specifically designed to
 be compatible with retail FreeSpace while still taking advantage of
 the additional features in FreeSpace Open.

Package: freespace2-mod-fsport-video
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
        ,freespace2-mod-fsport-campaign-greatwar
Recommends: freespace2, freespace2-launcher
Suggests: check-dfsg-status
Enhances: freespace2-mod-fsport-campaign-greatwar
Description: FreeSpace2 - fsport campaigns' cutscenes
 Original and community-developed cutscenes for "Great War" campaign.
 .
 The FreeSpace Port (fsport) is a mod for FreeSpace 2 that allows you to
 play the original Great War and Silent Threat campaigns in the newer
 FS2 engine, as well as specific user-made campaigns such as Silent
 Threat: Reborn. This version of the Port was specifically designed to
 be compatible with retail FreeSpace while still taking advantage of
 the additional features in FreeSpace Open.

Package: freespace2-mod-fsport-campaign-silentthreat
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
        ,freespace2-mod-fsport-campaign-greatwar
        ,freespace2-mod-mediavps (>= 3.6.12)
        ,freespace2-mod-fsport-mediavps
Recommends: freespace2, freespace2-mod-fsport-mediavps
Suggests: check-dfsg-status
Description: FreeSpace2 - "Silent Treat" campaign
 Original "Descent: FreeSpace – Silent Threat: Reborn" 1998 expansion
 campaign by Volition.
 .
 As the Great War rages on, you've been commissioned by Galactic Terran
 Intelligence for special intelligence operations. Your objectives are
 to contain the Shivan onslaught and preserve the fragile Terran-Vasudan
 alliance. But a series of suspicious events cloud the GTI's spotless
 record. Is the GTI setting you up or are the Shivans spreading their
 evil rage?
 .
 The FreeSpace Port (fsport) is a mod for FreeSpace 2 that allows you to
 play the original Great War and Silent Threat campaigns in the newer
 FS2 engine, as well as specific user-made campaigns such as Silent
 Threat: Reborn. This version of the Port was specifically designed to
 be compatible with retail FreeSpace while still taking advantage of
 the additional features in FreeSpace Open.

Package: freespace2-mod-fsport-campaign-awakenings
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
        ,freespace2-mod-fsport-campaign-greatwar
        ,freespace2-mod-mediavps (>= 3.6.12)
        ,freespace2-mod-fsport-mediavps
Recommends: freespace2, freespace2-mod-fsport-mediavps
Suggests: check-dfsg-status
Description: FreeSpace2 - "Awakenings" campaign
 Community-developed campaign "Awakenings".
 .
 Three years after the destruction of the original Lucifer, the GTA
 begins to rebuild their systems while fighting the Shivans and the
 Hammer of Light.
 .
 The FreeSpace Port (fsport) is a mod for FreeSpace 2 that allows you to
 play the original Great War and Silent Threat campaigns in the newer
 FS2 engine, as well as specific user-made campaigns such as Silent
 Threat: Reborn. This version of the Port was specifically designed to
 be compatible with retail FreeSpace while still taking advantage of
 the additional features in FreeSpace Open.

Package: freespace2-mod-fsport-campaign-cardinalspear
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
        ,freespace2-mod-fsport-campaign-greatwar
        ,freespace2-mod-mediavps (>= 3.6.12)
        ,freespace2-mod-fsport-mediavps
Recommends: freespace2, freespace2-mod-fsport-mediavps
Suggests: check-dfsg-status
Description: FreeSpace2 - "Cardinal spear" campaign
 Community-developed campaign "Cardinal spear".
 .
 In the tenth year of war against the Vasudans, humanity had
 attempted one last desperate strike to end the war outright - a spear
 in the dark. The Cardinal Fleet had been laid ruin, and the crew of
 the GTD Agamemnon was being hunted by a Vasudan general. It was too
 late for victory, but not too late for vengeance...
 .
 The FreeSpace Port (fsport) is a mod for FreeSpace 2 that allows you to
 play the original Great War and Silent Threat campaigns in the newer
 FS2 engine, as well as specific user-made campaigns such as Silent
 Threat: Reborn. This version of the Port was specifically designed to
 be compatible with retail FreeSpace while still taking advantage of
 the additional features in FreeSpace Open.

Package: freespace2-mod-fsport-campaign-destinyofpeace
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
        ,freespace2-mod-fsport-campaign-greatwar
        ,freespace2-mod-fsport
        ,freespace2-mod-mediavps (>= 3.6.12)
Recommends: freespace2, freespace2-mod-fsport-mediavps
Suggests: check-dfsg-status
Description: FreeSpace2 - "Destiny of peace" campaign
 Community-developed campaign "Destiny of peace".
 .
 Seven months have passed since the destruction of the Lucifer.  With
 the war over and the Terran-Vasudan alliance flourishing, the need for
 new GTA pilots has declined. As a gifted young pilot, this disappoints
 you. The only job you could land was busting speeders at GTA outposts.
 You begin to feel like you're never going to get your chance to live
 your dream. Things are about to change...
 .
 The FreeSpace Port (fsport) is a mod for FreeSpace 2 that allows you to
 play the original Great War and Silent Threat campaigns in the newer
 FS2 engine, as well as specific user-made campaigns such as Silent
 Threat: Reborn. This version of the Port was specifically designed to
 be compatible with retail FreeSpace while still taking advantage of
 the additional features in FreeSpace Open.

=== debian/packages/freespace2-mod-mediavps/debian/control ===
Source: freespace2-mod-mediavps
Section: non-free/games
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@member.fsf.org>
Build-Depends: debhelper (>= 9)
              ,diffutils
              ,dpkg-dev
              ,unzip
              ,wget
Standards-Version: 3.9.8
Homepage: http://scp.indiegames.us/bnr_mediavp.php

Package: freespace2-mod-mediavps
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: freespace2 (>= 23.2.0~), freespace2-video
Suggests: check-dfsg-status
Enhances: freespace2
Description: FreeSpace 2 - high resolution Media VPs
 The MediaVPs are a set of VP (container) files that add new art and
 effects to the FS2_Open engine. The MediaVPs contain all of the
 enhanced artwork and graphics that take advantage of the new
 capabilities of the FS2Open. These enhancements will apply to the
 original FreeSpace 2 campaign, or any campaigns based on it.
 .
 Note that these are not a replacement for the retail Freespace 2 VP files.
 .
 FreeSpace 2 is a 1999 space combat simulation computer game developed
 by Volition, Inc. as the sequel to Descent: FreeSpace – The Great
 War.
 The games take place in the 24th century. Mankind, referred to as
 Terrans, has developed means for space traveling, further fueled
 by the discovery of subspace which makes interstellar travel not
 only possible but also fast and easy. As a result the Terrans have
 expanded their territory, eventually encountering another bipedal,
 sentient species; the Vasudans. However, due to cultural differences
 and difficulties in communicating with each other, the Galactic Terran
 Alliance (GTA) and the Parliamentary Vasudan Empire (PVE) end up fighting
 a war that lasts for 14 years.

=== debian/packages/freespace2-data-volition/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	@echo "## checking integrity..."
	sha1sum --strict --check debian/files_sha1.txt

override_dh_builddeb:
	dh_builddeb -- -Zxz

get-orig-source:
	sha1sum --binary *.bmp *.vp | tee debian/files_sha1.txt

=== debian/packages/freespace2-mod-mediavps/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# parallel build by default on linux
ifeq ($(DEB_HOST_ARCH_OS),linux)
    ifeq ($(findstring parallel=,$(DEB_BUILD_OPTIONS)),)
        export DEB_BUILD_OPTIONS+=parallel=$(shell getconf _NPROCESSORS_ONLN)
    endif
endif
$(info DEB_BUILD_OPTIONS:$(origin DEB_BUILD_OPTIONS)=$(DEB_BUILD_OPTIONS))

PKD = $(abspath $(dir $(MAKEFILE_LIST)))
PKG = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))

%:
	dh $@ --parallel --max-parallel=3

override_dh_auto_configure:
	@echo "## checking integrity..."
	sha1sum --strict --check debian/files_sha1.txt

DD=$(CURDIR)/debian/$(PKG)/usr/share/games/freespace2-open/MediaVPs
override_dh_auto_install:
	[ -d "$(DD)" ] || mkdir -v -p "$(DD)"
#	for F in *.7z; do unzip -j "$$F" -d "$(DD)" ;done
	for F in *.7z; do 7za e -y -bd -o$(DD)/ "$$F" ;done

override_dh_builddeb:
	dh_builddeb -- -Zxz -z4

# https://www.hard-light.net/forums/index.php?topic=99050.0
get-orig-source:
	sha1sum --strict --check debian/files_sha1.txt \
	|| wget --tries=3 --timeout=60 --read-timeout=60 --wait=1 --random-wait --continue --timestamping \
            --recursive --level=1 --no-directories --no-parent --span-hosts --accept=7z \
            "https://fsnebula.org/mod/MVPS#expert_content"
	@echo "## generating checksums..."
	sha1sum --binary *.7z | tee debian/files_sha1.txt~NEW
	diff -U0 debian/files_sha1.txt debian/files_sha1.txt~NEW \
        && $(RM) debian/files_sha1.txt~NEW

## --recursive --level=1  --relative  --convert-links

=== debian/packages/freespace2-video/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PKD = $(abspath $(dir $(MAKEFILE_LIST)))
PKG = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))

%:
	dh $@ --parallel --max-parallel=3

override_dh_auto_configure:
	@echo "## checking integrity..."
	sha1sum --strict --check debian/files_sha1.txt

DD=$(CURDIR)/debian/$(PKG)/usr/share/games/freespace2-open/data/movies
override_dh_auto_install:
	[ -d "$(DD)" ] || mkdir -v -p "$(DD)"
	for F in *.zip; do unzip -j "$$F" -d "$(DD)" ;done

override_dh_builddeb:
	dh_builddeb -- -Zxz -z4

get-orig-source:
	sha1sum --strict --check debian/files_sha1.txt \
	|| wget --tries=3 --timeout=60 --read-timeout=60 --continue --timestamping --content-disposition \
            "https://porphyrion.feralhosting.com/datacorder/fsmods_files/fs2_ogg.zip"
	@echo "## generating checksums..."
	sha1sum --binary *.zip | tee debian/files_sha1.txt~NEW
	diff -U0 debian/files_sha1.txt debian/files_sha1.txt~NEW \
        && $(RM) debian/files_sha1.txt~NEW

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
VER  ?= $(shell sh -c 'printf "$${1%%+repack*}"' -- "$(DEB_VERSION_UPSTREAM)")
$(info VER=$(VER))

$(info DEB_BUILD_OPTIONS:$(origin DEB_BUILD_OPTIONS)=$(DEB_BUILD_OPTIONS))

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
$(info DEB_BUILD_MAINT_OPTIONS:$(origin DEB_BUILD_MAINT_OPTIONS)=$(DEB_BUILD_MAINT_OPTIONS))

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --builddirectory=_build --with quilt

override_dh_quilt_patch:
## Patch for Bookworm:
	if dpkg --compare-versions $$(dpkg --status libimgui-dev | grep Version | cut -d' ' -f2) lt 1.89; then \
            echo "series_bookworm" > .pc/.quilt_series ;\
        fi
	dh_quilt_patch


override_dh_auto_configure:
	cp -a cmake-modules cmake/external/rpavlik-cmake-modules
	cp -a librocket lib/libRocket
	cp -a lib/imgui/extensions code/imgui_extensions
	dh_auto_configure -- \
            -DCMAKE_BUILD_TYPE=Release \
            -DCMAKE_INSTALL_PREFIX=/usr/games/ \
        ;

#execute_after_dh_auto_build:
#	## building developer's documentation
#	doxygen _build/fs2open.Doxyfile

execute_after_dh_auto_clean:
	$(RM) -rf code/imgui_extensions
	$(RM) -rf lib/libRocket
	$(RM) -rf cmake/external/rpavlik-cmake-modules

override_dh_link:
	dh_link \
            /usr/games/fs2_open_$(VER)         /usr/games/fs2_open \
            /usr/games/fs2_open                /usr/share/games/freespace2-open/fs2_open \
            /usr/games/fs2_open_$(VER)         /usr/share/games/freespace2-open/fs2_open_$(VER) \
            /usr/share/man/man6/fs2_open.6.gz  /usr/share/man/man6/fs2_open_$(VER).6.gz \
        ;

=== debian/packages/freespace2-mod-mediavps/debian/watch ===
# uscan(1)

# this file is for update checking only.
# use "debian/rules get-orig-source" to get upstream archives.

version=3

opts=\
uversionmangle=s/(\d)(\d)(\d+)/$1.$2.$3/,\
dversionmangle=s/\+upd\d+//,\
 https://www.hard-light.net/forums/index.php?topic=99050.0 \
 */MediaVPs_(\d+)\.zip

=== debian/packages/freespace2-video/debian/watch ===
# uscan(1)

# this file is for update checking only.
# use "debian/rules get-orig-source" to get upstream archives.

version=3

=== debian/watch ===
# https://salsa.debian.org/snippets/95
# https://wiki.debian.org/debian/watch
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
compression=xz,\
repack,repacksuffix=+repack,\
dversionmangle=s{[+~](repack|dfsg)\d*}{},\
uversionmangle=s{_RC}{~rc};s{_}{.}g,\
filenamemangle=s{release_([\d\._]+)}{@PACKAGE@-$1.tar.gz},\
searchmode=plain,\
" https://api.github.com/repos/scp-fs2open/fs2open.github.com/releases?per_page=99 \
  https://api.github.com/repos/[^/]+/[^/]+/tarball/v?release_([\d._]+) \
  debian uupdate

#opts="\
#pgpmode=none,\
#repack,compression=xz,repacksuffix=+repack,\
#dversionmangle=s/\+repack\d*//,\
#uversionmangle=s/_RC/~rc/;s/_/./g,\
#" https://uscan.tianon.xyz/github.com/scp-fs2open/fs2open.github.com \
#  .*/archive/(?:release_|fs2_open_)(\d[\d._RC]+)(?:_final)?\.(?:tgz|tbz2|tar\.gz|tar\.bz2|tar\.xz)


# librocket
opts="component=librocket, \
      mode=git, \
      pgpmode=none, \
      pretty=%cd.%h, \
      repack, \
      compression=xz, \
      dversionmangle=auto" \
https://github.com/scp-fs2open/libRocket.git HEAD \
ignore

# cmake-modules
opts="component=cmake-modules, \
      mode=git, \
      pgpmode=none, \
      pretty=%cd.%h, \
      repack, \
      compression=xz, \
      dversionmangle=auto" \
https://github.com/asarium/cmake-modules.git HEAD \
ignore
